package com.hongyegroup.cpt_main.widget;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.guadou.lib_baselib.utils.CommUtils;
import com.hongyegroup.cpt_main.R;

import java.util.concurrent.TimeUnit;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;

public class AccountDeactivationDialog extends DialogFragment {

    private ImageView mCancelIv;
    private TextView mYesTv;
    private TextView mNolTv;

    private OnAccountDeactivationDialogClickListener mListener;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        View inflate = LayoutInflater.from(CommUtils.getContext()).inflate(R.layout.dialog_account_deactivation, null);

        return inflate;
    }


    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        mCancelIv = view.findViewById(R.id.iv_dialog_account_deactivation_cancel);
        mYesTv = view.findViewById(R.id.tv_dialog_account_deactivation_yes);
        mNolTv = view.findViewById(R.id.tv_dialog_account_deactivation_no);

        initListener();

    }

    @SuppressLint("CheckResult")
    private void initListener() {

        //点击Cancel
        mCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                dismiss();

            }
        });

        //点击Yes
        mYesTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                if (mListener != null) {

                    mListener.onClickYes();

                }

                dismiss();

            }
        });

        //点击No
        mNolTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                dismiss();

            }
        });

    }

    public void setOnAccountDeactivationDialogListener(OnAccountDeactivationDialogClickListener listener) {

        mListener = listener;

    }

    public interface OnAccountDeactivationDialogClickListener {

        void onClickYes();

    }

}
