package com.hongyegroup.cpt_parttime.ui.fragment

import android.os.Bundle
import com.guadou.cs_cptservices.base.fragment.YYBaseVDBLoadingFragment
import com.guadou.cs_cptservices.interfaces.IFragmentRefresh
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.ext.checkEmpty
import com.guadou.lib_baselib.ext.vertical
import com.hongyegroup.cpt_parttime.R
import com.hongyegroup.cpt_parttime.databinding.FragmentParttimeJobDetailGroomingBinding
import com.hongyegroup.cpt_parttime.mvvm.PartJobDetailGroomingViewModel

/**
 * 工作详情 子页面 展示推荐的工作
 */
class PartJobDetailGroomingFragment : YYBaseVDBLoadingFragment<PartJobDetailGroomingViewModel, FragmentParttimeJobDetailGroomingBinding>(), IFragmentRefresh {

    override fun getDataBindingConfig(): DataBindingConfig {
        return DataBindingConfig(R.layout.fragment_parttime_job_detail_grooming)

    }

    override fun init(savedInstanceState: Bundle?) {
        initRV()
    }

    override fun onResume() {
        super.onResume()

        if (mViewModel.mDatas.checkEmpty()){
            mViewModel.getGroomingData()
        }
    }

    private fun initRV() {
        mBinding.rvGrooming.vertical().apply {
            adapter = mViewModel.mAdapter
        }
    }

    override fun startObserve() {
    }

    override fun scrollTopRefresh() {

    }

}