package com.hongyegroup.cpt_rewards.ui

import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.widget.LinearLayout
import com.guadou.lib_baselib.base.activity.BaseVDBActivity
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.ext.vertical
import com.guadou.lib_baselib.utils.CommUtils
import com.hongyegroup.cpt_rewards.BR
import com.hongyegroup.cpt_rewards.R
import com.hongyegroup.cpt_rewards.databinding.ActivityRewardsListBinding
import com.hongyegroup.cpt_rewards.databinding.ActivityRewardsListBindingImpl
import com.hongyegroup.cpt_rewards.mvvm.RewardsListViewModel
import com.hongyegroup.cpt_rewards.widget.RewardsSortByXPopup
import com.luck.picture.lib.tools.ToastUtils
import com.lxj.xpopup.XPopup
import com.lxj.xpopup.enums.PopupAnimation

class RewardsListActivity : BaseVDBActivity<RewardsListViewModel, ActivityRewardsListBinding>() {

    val mClickProxy by lazy { ClickProxy() }
    var mSortByLl: LinearLayout? = null

    companion object {

        fun startInstance() {
            val context = CommUtils.getContext()
            val intent = Intent(context, RewardsListActivity::class.java)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
        }

    }

    override fun init(savedInstanceState: Bundle?) {

        initView()

    }

    private fun initView() {

        mSortByLl = findViewById<LinearLayout>(R.id.ll_rewards_recommend_sort_by)

        for (index in 0..9) {

            mViewModel.mRewardsListData.add("")

        }

        mBinding.recyclerViewRewardsList.vertical().adapter = mViewModel.mRewardsListAdapter
        mViewModel.mRewardsListAdapter.notifyDataSetChanged()

    }

    override fun getDataBindingConfig(): DataBindingConfig {

        return DataBindingConfig(R.layout.activity_rewards_list, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, mClickProxy)

    }

    override fun startObserve() {

    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        //显示Sort By弹框
        fun showSortByXPopup() {

            ToastUtils.s(mContext, "Sort By")

            XPopup.Builder(mActivity)
                .atView(mBinding.llRewardsRecommendSort)
//                .atView(mSortByLl)
                .popupAnimation(PopupAnimation.NoAnimation)
                .hasShadowBg(false)
                .asCustom(
                    RewardsSortByXPopup(mActivity, /*mPresenter.mSortById, mPresenter.mSortId,
                        Integer.valueOf(mPresenter.mMinPoints), Integer.valueOf(mPresenter.mMaxPoints), */object : RewardsSortByXPopup.OnClickRewardsSortByXPopupListener {
                        override fun onClickApply(sortById: String?, sortId: String?, startPoint: Int, endPoint: Int) {

//                            mPresenter.mSortById = sortById
//                            mPresenter.mSortId = sortId
//                            mPresenter.mMinPoints = startPoint.toString()
//                            mPresenter.mMaxPoints = endPoint.toString()
//
//                            //SortBy 1 popular(点击量) 2distance(折扣比例) 3point(积分) 4 latest(最新发布)
//                            if (!TextUtils.isEmpty(sortById)) {
//                                if (sortById == "1") {
//                                    mSortByTv.setText(CommUtils.getString(R.string.popularity))
//                                } else if (sortById == "4") {
//                                    mSortByTv.setText(CommUtils.getString(R.string.latest))
//                                }
//                            }
//
//                            // sort 1从小到大 2从大到小
//                            if (!TextUtils.isEmpty(sortId)) {
//                                if (sortId == "1") {
//                                    mSortByTv.setText(CommUtils.getString(R.string.low_to_high_points))
//                                } else if (sortId == "2") {
//                                    mSortByTv.setText(CommUtils.getString(R.string.high_to_low_points))
//                                }
//                            }
//                            mRefreshLayout.autoRefresh()

                        }

                    })
                )
                .show()

        }

    }

}